<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"

	xmlns:java="http://xml.apache.org/xslt/java"
	xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
	xmlns:gslib="http://www.greenstone.org/skinning"
    xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"
    
    xmlns:lxslt="http://xml.apache.org/xslt"
    xmlns:result="http://www.example.com/results"
    xmlns:exsl="http://exslt.org/common"

	extension-element-prefixes="java util result exsl"
	exclude-result-prefixes="util java util">
  <!--
  <xsl:import href="footer.xsl"/>
  -->
  
<!-- The main layout is defined here -->
<!-- Every page in our library uses this template -->
<xsl:template name="mainTemplate">
  <html>
    <head>
      <!-- ***** in header.xsl ***** -->
      <xsl:call-template name="create-html-header"/>
      <xsl:call-template name="basketHeadTags"/>	
    </head>
    <body id="top" class="banner-overlay-on">
      <div id="spacer-for-nav">&#160;</div>
      <div class="wrapper">
	<div class="shifted-frame">
	
	<!-- Whakatohea.co.nz's navbar - no longer in use now that the dl site is
	     embedded in iframe on whakatohea.co.nz site which provides the navbar -->
	<!--<xsl:call-template name="whakatohea-navbar"/>-->
	
	<div class="site-canvas">

	  <div class="wrapper-old">
	    <div id="header-old">
	      
	      <div class="banner-wrap">
		<div class="wsite-elements wsite-not-footer wsite-header-elements">
		  <div class="wsite-section-wrap">
		      <!--<div  class="wsite-section wsite-header-section wsite-section-bg-image" style="height: auto;background-image: url(&quot;interfaces/{$interface_name}/images/digital-library.jpg&quot;) ;background-repeat: no-repeat ;background-position: 50.00% 21.94% ;background-size: 100% ;background-color: transparent ;background-size: cover;" >-->
		    <div style="background-image: url(&quot;interfaces/{$interface_name}/images/digital-library.jpg&quot;);" >
		      <xsl:choose>
			<xsl:when test="/page/pageResponse/collection or /page/pageResponse/pathList/group">
			  <xsl:attribute name="class">wsite-section wsite-header-section wsite-section-bg-image crop-bg</xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
			  <xsl:attribute name="class">wsite-section wsite-header-section wsite-section-bg-image full-bg</xsl:attribute>
			</xsl:otherwise>
		      </xsl:choose>
		      
		      <div class="wsite-section-content">
			
			<div class="container">
			  <div class="banner">
			    <div class="wsite-section-elements">
			      <h2 class="wsite-content-title" style="text-align:center;"><font size="6"><a href="{$library_name}"><xsl:call-template name="siteName"/></a></font></h2>

			      <!-- Why does this feel like it's still inside the banner-wrap? -->
			      <xsl:choose>
				<xsl:when test="page/pageResponse/collection">
				  <div id="coll-name-link">
				    <p>&#160;
				    <a href="{$library_name}/collection/{$collNameChecked}/page/about">
				      <xsl:value-of select="page/pageResponse/collection/displayItemList/displayItem[@name='name']"/>
				    </a>
				    </p>
				    <br class="clear"/>
				  </div>
				</xsl:when>

				<xsl:when test="/page/pageRequest/paramList/param[@name='group']/@value">
				  <div id="coll-name-link">
				    <p>
				      <xsl:value-of select="/page/pageRequest/paramList/param[@name='group']/@value"/>
				  </p>
				  <br class="clear"/>
				  </div>
				</xsl:when>
			      </xsl:choose>			      
			    </div>
			  </div>
			</div>
			
		      </div>
		      <!--<div class=""></div>-->
		    </div>
		  </div>
		  
		</div>

			  
		<div class="container wrapper-old col2" id="browse-search-bars">
		  <div id="topbar">
		    <xsl:choose>
		      <xsl:when test="page/pageRequest/@subaction='home'">
			<div id="cross-coll-div">
			  <xsl:call-template name="crossCollSearch"/>
			</div>
		      </xsl:when>
		      <xsl:when test="page/pageRequest/paramList/param/@name='c' and /page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']">
			<xsl:call-template name="quick-search-area"/>
		      </xsl:when>
		      <xsl:otherwise/>
		    </xsl:choose>
		    <!--**********************************************************************-->
		  </div>
		</div>

		
	      </div><!-- end banner-wrap -->
	    </div>
	  </div>

	  <!--<xsl:call-template name="login-prefs-help-links"/>-->
	  <!--<hr class="spacer" />-->
	  <div class="outer">
			<xsl:if test="page/pageResponse/collection">
				<xsl:attribute name="class">outer collectionDisplay</xsl:attribute>
				<xsl:call-template name="sideNavBar"/>
			</xsl:if>
		  
	    <div id="gs_content" class="container">
	      <xsl:apply-templates select="/page"/>				
	    </div>
	    <br class="clear" />
	    
	  </div><!-- end class main-wrap-->
	  <xsl:call-template name="wmtb-footer"/>
	  
	</div> <!-- end site-canvas -->
      </div> <!-- end shifted-frame -->
      </div> <!-- end wrapper-->
		</body>
	</html>
</xsl:template>

<xsl:template name="sideNavBar">
  <div class="side-navbar">
		<!--
			Using select statement to count only non-empty elements, is harder than testing
			for non-empty elements. Solution of using normalize-space() is from
			https://stackoverflow.com/questions/31602369/xsl-return-only-the-first-non-empty-element
		-->
		<xsl:variable name="classifierCount" select="count(/page/pageResponse/collection/serviceList/service[@name='ClassifierBrowse']/classifierList/classifier/displayItem[@name = 'name'][normalize-space()])"/>

		<!-- TODO: Hardcoded strings! -->

		<a href="{$library_name}">Our Six Pou</a>

		<a href="{$library_name}/collection/{$collNameChecked}/page/about">
			<xsl:if test="page/pageRequest/@subaction='about'">
				<xsl:attribute name="class">active</xsl:attribute>
			</xsl:if>

			About Collection
		</a>

		<hr class="side-navbar-separator" />

		<xsl:if test="$classifierCount > 0">
			<span>Browse by:</span>
			<ul>
				<xsl:call-template name="listBrowsingClassifiers"/>
			</ul>
		</xsl:if>

		<!--Login link is disabled, as it was determined to be confusing with Whakatohea's existing login elements -->
		<!-- <hr class="side-navbar-separator" />
		<xsl:call-template name="loginLinks"/> -->
	</div>
</xsl:template>

<!--
	This was in the old navbar. Might come in useful?

	<xsl:variable name="currentPage" select="page/pageRequest/@fullURL"/>
	<xsl:if test="/page/pageResponse/collection/serviceList/service/@type='query'">
		<li>
			<a href="{$currentPage}">Search</a>
			<ul>
				<xsl:for-each select="/page/pageResponse/collection/serviceList/service[@type='query']">
					<xsl:variable name="search" select="@name"/>
					<xsl:variable name="search_name" select="displayItem[@name='name']"/>

					<li>
						<a href="{$library_name}/collection/{$collNameChecked}/search/{$search}">
							<xsl:value-of select="$search_name"/>
						</a>
					</li>
				</xsl:for-each>
			</ul>
		</li>
	</xsl:if>
-->

<!-- Builds a list of the named browsing classifiers that are defined in the response. -->
<xsl:template name="listBrowsingClassifiers">
  <xsl:for-each select="/page/pageResponse/collection/serviceList/service[@name='ClassifierBrowse']/classifierList/classifier">
    <xsl:choose>
      <!--
				Only display browsing classifiers that have a name.
				Those that don't have a name are empty classifiers
				denoted by no value/empty value for displayItem name=name elements.
				Testing for non empty elements is easy: not() test.
			-->
      <xsl:when test="not(displayItem[@name='name'] ='')">
				<li>
					<a>
						<!-- Indicates that this classifier's content is being displayed -->
						<xsl:if test="util:contains(/page/pageRequest/paramList/param[@name = 'cl' and /page/pageRequest/@action = 'b']/@value, @name)">
							<xsl:attribute name="class">active</xsl:attribute>
						</xsl:if>

						<!-- Add a title element to the <a> tag if a description exists for this classifier -->
						<xsl:if test="displayItem[@name='description']">
							<xsl:attribute name='title'><xsl:value-of select="displayItem[@name='description']"/></xsl:attribute>
						</xsl:if>

						<!-- Add the href element to the <a> tag -->
						<xsl:choose>
							<xsl:when test="@name">
								<xsl:attribute name="href">
									<xsl:value-of select="$library_name"/>/collection/<xsl:value-of select="/page/pageResponse/collection[@name=$collNameChecked]/@name"/>/browse/<xsl:value-of select="@name"/>
								</xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="href">
									<xsl:value-of select="$library_name"/>/collection/<xsl:value-of select="/page/pageResponse/collection[@name=$collNameChecked]/@name"/>/browse/1
								</xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>

						<!-- Add the actual text of the <a> tag -->
						<xsl:value-of select="displayItem[@name='name']"/>
					</a>
				</li>
			</xsl:when>
		</xsl:choose>
	</xsl:for-each>
</xsl:template>

<xsl:template name="crossCollSearch">
	<div id="search">
		<xsl:for-each select="/page/pageResponse/serviceList/service[@name='TextQuery']">
			<form name="QuickSearch" method="get" action="{$library_name}">
				<input type="hidden" name="a" value="q"/>
				<input type="hidden" name="rt" value="rd"/>
				<input type="hidden" name="s" value="{@name}"/>
				<input type="hidden" name="s1.collection" value="all"/>
				<input type="text" name="s1.query" id="search-text" value="Search all collections…" onfocus="this.value=(this.value=='Search all collections…')? '' : this.value ;" />
				<input type="submit" name="go" id="go" value="Search" />
			</form>
		</xsl:for-each>
	</div>
	<br class="clear" />
</xsl:template>

<xsl:template name="CollectionSearch">
<div id="search">
<xsl:variable name="subaction" select="/page/pageRequest/@subaction"/>
<form action="{$library_name}/collection/{$collNameChecked}/search/TextQuery">
<!-- This parameter says that we have come from the quick search area -->
<input type="hidden" name="qs" value="1"/>
<input type="hidden" name="rt" value="rd"/>
<input type="hidden" name="s1.level">
<xsl:attribute name="value">
<xsl:choose>
<xsl:when test="/page/pageRequest/paramList/param[@name = 's1.level']">
<xsl:value-of select="/page/pageRequest/paramList/param[@name = 's1.level']/@value"/>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="/page/pageResponse/collection/serviceList/service[@name='TextQuery']/paramList/param[@name = 'level']/@default"/>
</xsl:otherwise>
</xsl:choose>
</xsl:attribute>
</input>
<xsl:choose>
<xsl:when test="/page/pageResponse/service[@name = 'TextQuery']/paramList/param[@name = 'startPage']">
<input type="hidden" name="s1.startPage" value="1"/>
</xsl:when>
<xsl:otherwise>
<input type="hidden" name="startPage" value="1"/>
</xsl:otherwise>
</xsl:choose>
<xsl:if test="not(/page/pageRequest/paramList/param[@name = 's1.hitsPerPage'])">
<input type="hidden" name="s1.hitsPerPage" value="20"/>
</xsl:if>
<xsl:if test="not(/page/pageRequest/paramList/param[@name = 's1.maxDocs'])">
<input type="hidden" name="s1.maxDocs" value="100"/>
</xsl:if>
<!-- The query text box -->
<span class="querybox">
<xsl:variable name="qs">
<xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='query']" mode="calculate-default"/>
</xsl:variable>
<nobr>
<xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='query']">
<xsl:with-param name="default" select="java:org.greenstone.gsdl3.util.XSLTUtil.tidyWhitespace($qs, /page/@lang)"/>
</xsl:apply-templates>
</nobr>
</span>
<!-- The submit button (for TextQuery) -->
<xsl:if test="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']">
<input type="submit" name="go" id="go" value="Search" > </input>
<br/>
</xsl:if>
</form>
</div>
<br class="clear" />
<!--<div id="advanced"><a href="{$library_name}/collection/{$collNameChecked}/search/TextQuery">advanced search</a></div>-->
</xsl:template>


<xsl:template name="loginLinks">
	<xsl:variable name="username" select="/page/pageRequest/userInformation/@username"/>
	<xsl:variable name="groups" select="/page/pageRequest/userInformation/@groups"/>

	<xsl:choose>
	  <xsl:when test="$username">
	    <!-- Depositor link: only for logged-in users.
		 CSS class=login to make Depositor link blue to indicate it's only available when logged in.
		 Don't put this depositorTitleAndLink inside the test for whether user 'admin' is
		 in the current list of groups, as we want the depositor link to be visible for any
		 logged in user. The collection they want to deposit a doc into will determine whether
		 that user has the right to modify that collection.
	    -->			
	    <xsl:if test="contains($groups,'admin')">
	      <li class="login"><gslib:depositorTitleAndLink/></li> <!-- move back up/outside if admin test if non-admin members should be able to deposit -->
				<li class="login"><a href="{$library_name}/admin/AddUser">Add user</a></li>
				<li class="login"><a href="{$library_name}/admin/ListUsers">Administration</a></li>
				<li class="login"><a href="{$library_name}/admin/AccountSettings?s1.username={$username}">Logged in as: <xsl:value-of select="$username"/></a></li><!-- move back up/outside if admin test if non-admin members should be able to reset their password -->
			</xsl:if>			
			<li class="login"><a href="{$library_name}?logout=">Logout</a></li>
		</xsl:when>
		<xsl:otherwise>
			<li class="login">
			<a href="{$library_name}?a=p&amp;sa=login&amp;redirectURL={$library_name}%3Fa=p%26sa=home">Login
				<xsl:attribute name="title">
				<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'login_tip')"/>
				</xsl:attribute>
			</a>
			</li>
			</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="quick-search-area">
    <xsl:if test="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@type='query']">
      <xsl:variable name="subaction" select="/page/pageRequest/@subaction"/>

      <div id="quicksearcharea">
	<xsl:if test="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']">
	  <xsl:choose>
	    <xsl:when test="not(page/pageRequest[@action='q']) or /page/pageRequest/paramList/param[@name='qs']/@value = '1'">
	      <form action="{$library_name}/collection/{$collNameChecked}/search/TextQuery">
		<!-- This parameter says that we have come from the quick search area -->
		
		<input type="hidden" name="qs" value="1"/>
		<input type="hidden" name="rt" value="rd"/>
		<!-- don't hide indexing levels: code further down will hide it if there's only 1 indexing level.
		     and display a dropdown if the collection's configured with more than 1 index level available -->
		<!--<input type="hidden" name="s1.level">
		  <xsl:attribute name="value">
		    <xsl:value-of select="/page/pageResponse/collection/serviceList/service[@name='TextQuery']/paramList/param[@name = 'level']/@default"/>
		  </xsl:attribute>
		</input>
		-->
		<xsl:choose>
		  <xsl:when test="/page/pageResponse/service[@name = 'TextQuery']/paramList/param[@name = 'startPage']">
		    <input type="hidden" name="s1.startPage" value="1"/>
		  </xsl:when>
		  <xsl:otherwise>
		    <input type="hidden" name="startPage" value="1"/>
		  </xsl:otherwise>
		</xsl:choose>

		<!-- The query text box -->
		Search for
		<span class="querybox">
		  <xsl:variable name="qs">
		    <xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='query']" mode="calculate-default"/>
		  </xsl:variable>
		  <nobr>
		    <xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='query']">
		      <!--
			  <xsl:with-param name="default" select="java:org.greenstone.gsdl3.util.XSLTUtil.tidyWhitespace($qs, /page/@lang)"/>
		      -->
		      <xsl:with-param name="default" select="normalize-space($qs)"/>
		      
		    </xsl:apply-templates>
		  </nobr>
		</span>
		<!-- The index selection list -->
		in
		<xsl:if test="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='index']/@type = 'enum_single'">
		  <span class="textselect">
		    <xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='index']">
		      <xsl:with-param name="default">
			<xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='index']" mode="calculate-default"/>
		      </xsl:with-param>
		      <xsl:with-param name="hideSingle">false</xsl:with-param>
		      <xsl:with-param name="quickSearch">true</xsl:with-param>
		    </xsl:apply-templates>
		  </span>
		</xsl:if>
		<!-- The partition selection list -->						
		<xsl:if test="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='indexSubcollection']/@type = 'enum_single'">
		  <span class="textselect">
		    <xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='indexSubcollection']">
		      <xsl:with-param name="default">
			<xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='indexSubcollection']" mode="calculate-default"/>
		      </xsl:with-param>
		      <xsl:with-param name="hideSingle">true</xsl:with-param>
		      <xsl:with-param name="quickSearch">true</xsl:with-param>
		    </xsl:apply-templates>
		  </span>
		</xsl:if>

		<!-- The index level selection list. hideSingle=true to hide the dropdown if there's only 1 level (the default). -->
		at
		<xsl:if test="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='level']/@type = 'enum_single'">
		  <span class="textselect">
		    <xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='level']">
		      <xsl:with-param name="default">
			<xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='level']" mode="calculate-default"/>
		      </xsl:with-param>
		      <xsl:with-param name="hideSingle">true</xsl:with-param>
		      <xsl:with-param name="quickSearch">true</xsl:with-param>
		    </xsl:apply-templates>
		  </span>
		</xsl:if>
		level
		
		<!-- The language selection list -->						
		<xsl:if test="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='indexLanguage']/@type = 'enum_single'">
		  <span class="textselect">
		    <xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='indexLanguage']">
		      <xsl:with-param name="default">
			<xsl:apply-templates select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/paramList/param[@name='indexLanguage']" mode="calculate-default"/>
		      </xsl:with-param>
		      <xsl:with-param name="hideSingle">true</xsl:with-param>
		      <xsl:with-param name="quickSearch">true</xsl:with-param>
		    </xsl:apply-templates>
		  </span>
		</xsl:if>							
		<!-- The submit button (for TextQuery) -->
		<xsl:if test="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']">
		  <!--<input type="submit" id="quickSearchSubmitButton">
		      <xsl:attribute name="value">
		      <xsl:value-of select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@name='TextQuery']/displayItem[@name='submit']"/>
		      </xsl:attribute>
		      </input>-->

		  <input type="submit" id="quickSearchSubmitButton" value="Go"/>

		  <br/>
		</xsl:if>
	      </form>
	      
	      <div class="query-form-links" id="advanced"><a href="{$library_name}/collection/{$collNameChecked}/search/AdvancedFieldQuery">Advanced search</a></div>
	      
	    </xsl:when>
	    <xsl:otherwise><br/></xsl:otherwise>
	  </xsl:choose>			
	</xsl:if>

      </div>
      <!--<br class="clear" />-->
      <!--<span id="advanced">-->

      <!-- The list of other search types -->      
      <!--<xsl:call-template name="all-other-search-form-links"/>-->

      
    </xsl:if>

    
    <!--<br class="clear" />
    <div id="advanced"><a href="{$library_name}/collection/{$collNameChecked}/search/TextQuery">form search</a></div>
    <div id="advanced"><a href="{$library_name}/collection/{$collNameChecked}/search/AdvancedFieldQuery">advanced search</a></div>
    -->
  </xsl:template>

  <!-- Bar that links to other search forms -->
  <xsl:template name="all-other-search-form-links">
      <!-- The list of other search types -->      
      <div class="query-form-links">
	<ul>
	  <xsl:for-each select="/page/pageResponse/collection[@name=$collNameChecked]/serviceList/service[@type='query']">
	    <xsl:if test="/page/pageRequest/paramList/param[@name='qs']/@value = 1 or not(@name = /page/pageRequest/paramList/param[@name='s']/@value)">
	      <li class="ui-state-default ui-corner-all">
		    <a class="query-form-links">
		      <xsl:attribute name="href">
			<xsl:value-of select="$library_name"/>/collection/<xsl:value-of select="$collNameChecked"/>/search/<xsl:value-of select="@name"/>
		      </xsl:attribute>
		      <xsl:value-of select="displayItem[@name='name']"/>
		    </a>
	      </li>
	    </xsl:if>
	  </xsl:for-each>
	</ul>
      </div>
    
  </xsl:template>

  <!-- navigation bar for login, preferences and help links -->
  <xsl:template name="login-prefs-help-links">
	  <div class="container wrapper-old col0" style="margin:10px auto"> <!-- used to be 10px 30px -->
	    <div id="topline">
	      <ul>
		<xsl:call-template name="loginLinks"/>		    		
		<li><a href="{$library_name}/collection/{$collNameChecked}/page/pref">Preferences</a></li>
		<xsl:choose>
		  <xsl:when test="/page/pageResponse/collection">
		    <li><a href="{$library_name}/collection/{$collNameChecked}/page/help">Help</a></li>
		  </xsl:when>  
		  <xsl:otherwise>
		    <li><a href="{$library_name}/page/help">Help</a></li>
		  </xsl:otherwise>		
		</xsl:choose>
	      </ul>
	      <br class="clear" />
	    </div>
	  </div>    
  </xsl:template>
  
</xsl:stylesheet>
